'use strict';

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _racer = require('racer');

var _racer2 = _interopRequireDefault(_racer);

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var _trackerjs = require('trackerjs');

var _trackerjs2 = _interopRequireDefault(_trackerjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var util = _racer2.default.util;

var Model = _racer2.default.Model;

var DependencyManager = function DependencyManager() {
  this.deps = {};
};

DependencyManager.prototype.changed = function (deps) {
  if (deps['__dep']) {
    deps['__dep'].changed();
    delete deps['__dep'];
  }
  var keys = (0, _keys2.default)(deps);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(keys), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      this.changed(deps[key]);
      delete deps[key];
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

DependencyManager.prototype.find = function (segments) {
  var leaf = this.deps || {};
  if (!segments) return;

  for (var i = 0, len = segments.length; i < len; i++) {
    var segment = segments[i];
    leaf[segment] = leaf[segment] || {};
    leaf = leaf[segment];
  }
  return leaf;
};

DependencyManager.prototype.get = function (segments) {
  if (!_trackerjs2.default.currentComputation) return;

  var leaf = this.find(segments);

  if (!leaf.__dep) leaf.__dep = new _trackerjs2.default.Dependency();
  leaf.__dep.depend();
};

DependencyManager.prototype.set = function (segments) {
  var leaf = this.deps || {};

  for (var i = 0, len = segments.length; i < len; i++) {
    var segment = segments[i];
    if (!leaf) break;
    leaf = leaf[segment];
  }

  if (leaf) {
    this.changed(leaf);
  }
};

Model.prototype.deps = new DependencyManager();

Model.prototype._get = function (segments) {
  if (this.deps) this.deps.get(segments);
  return util.lookup(segments, this.root.data);
};

_model2.default.on('all', function fnListener(segments) {
  if (_model2.default.deps) _model2.default.deps.set(segments);
});

_trackerjs2.default.once = function (name, context, dataFunc, updateFunc) {
  var data = void 0;

  // Stop it just in case the autorun never re-ran
  if (context[name] && !context[name].stopped) context[name].stop();

  // NOTE: we may want to run this code in `setTimeout(func, 0)` so it doesn't impact the rendering phase at all
  context[name] = _trackerjs2.default.nonreactive(function () {
    return _trackerjs2.default.autorun(function (c) {
      if (c.firstRun) {
        data = dataFunc.call(context);
      } else {
        // Stop autorun here so rendering "phase" doesn't have extra work of also stopping autoruns; likely not too
        // important though.
        if (context[name]) context[name].stop();

        // where `forceUpdate` will be called in above implementation
        updateFunc.call(context);
      }
    });
  });

  return data;
};