'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

var _model = require('../model');

var _model2 = _interopRequireDefault(_model);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Updates to the following fields are going to be ignored (props WON'T be updated)
var IGNORE_FIELDS = ['_meta', 'updatedAt', 'updatedBy'];
var MAX_LISTENERS = 100;

var DocListener = function (_EventEmitter) {
  (0, _inherits3.default)(DocListener, _EventEmitter);

  function DocListener(collection, docId) {
    (0, _classCallCheck3.default)(this, DocListener);

    var _this = (0, _possibleConstructorReturn3.default)(this, (DocListener.__proto__ || (0, _getPrototypeOf2.default)(DocListener)).call(this));

    _this.collection = collection;
    _this.docId = docId;
    return _this;
  }

  (0, _createClass3.default)(DocListener, [{
    key: 'init',
    value: function init() {
      var _this2 = this;

      var collection = this.collection,
          docId = this.docId;

      var shareDoc = _model2.default.connection.get(collection, docId);
      if (!shareDoc) return console.error('Doc not found:', collection, docId);
      shareDoc.setMaxListeners(MAX_LISTENERS);
      this.listeners = [];
      var fn = function fn() {
        return _this2.emit('update');
      };['op', 'del', 'create'].forEach(function (eventName) {
        var handler = fn;
        // Filter `op` ops to ignore changes to the IGNORE_FIELDS
        if (eventName === 'op') {
          handler = function handler(op) {
            if (_lodash2.default.isArray(op) && op[0] && op[0].p && IGNORE_FIELDS.indexOf(op[0].p[0]) !== -1) {
              return;
            }
            fn();
          };
        }
        shareDoc.on(eventName, handler);
        _this2.listeners.push({
          ee: shareDoc,
          eventName: eventName,
          fn: handler
        });
      });
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      this.removeAllListeners();
      if (!this.listeners) return;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(this.listeners), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var listener = _step.value;

          listener.ee.removeListener(listener.eventName, listener.fn);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      delete this.listeners;
    }
  }]);
  return DocListener;
}(_eventemitter2.default);

exports.default = DocListener;
module.exports = exports['default'];