'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = local;

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var _trackerjs = require('trackerjs');

var _trackerjs2 = _interopRequireDefault(_trackerjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_COLLECTION = '$components';

function local(Component) {
  var _componentWillMount = Component.prototype.componentWillMount;
  Component.prototype.componentWillMount = function () {
    this.model = generateScopedModel();
    this.autorunRender();

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (_componentWillMount) _componentWillMount.call.apply(_componentWillMount, [this].concat(args));
  };
  var _componentWillUnmount = Component.prototype.componentWillUnmount;
  Component.prototype.componentWillUnmount = function () {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    if (_componentWillUnmount) _componentWillUnmount.call.apply(_componentWillUnmount, [this].concat(args));
    this.model.destroy();
    delete this.model;
  };
  Component.prototype.autorunRender = function () {
    var _this = this;

    var oldRender = this.render;
    this.render = function () {
      // Simple method we can offer in the `Meteor.Component` API
      return _this.autorunOnce('_renderComputation', oldRender);
    };
  };
  Component.prototype.autorunOnce = function (name, dataFunc) {
    return _trackerjs2.default.once(name, this, dataFunc, this.forceUpdate);
  };
  return Component;
}

function generateScopedModel() {
  var path = DEFAULT_COLLECTION + '.' + _model2.default.id();
  return _model2.default.scope(path);
}
module.exports = exports['default'];