'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = singleton;

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_COLLECTION = '$components';

function singleton(Component) {
  var model = generateScopedModel();
  Component.model = model;
  Component.path = model.path.bind(model);
  var _componentWillUnmount = Component.prototype.componentWillUnmount;
  Component.prototype.componentWillUnmount = function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (_componentWillUnmount) _componentWillUnmount.call.apply(_componentWillUnmount, [this].concat(args));
    model.destroy();
  };
  return Component;
}

function generateScopedModel() {
  var path = DEFAULT_COLLECTION + '.' + _model2.default.id();
  return _model2.default.scope(path);
}
module.exports = exports['default'];